#include <asm/types.h>
#include "../ocera_streams/ocs.h"

extern ocs_t         *ocn_ost_p;

#ifdef ODEBUG
extern int  ocs_deblevel;
#define OCN_DEBSOCKET(level,s) { ocn_showsocket(s); }
#else
#define OCN_DEBSOCKET(s) {}
#endif


#define OCERA_NET_LOADED    1
#define OCERA_NET_STARTED   2
#define OCERA_NET_STOPPED   3

extern long ocera_net_state;
extern struct proc_dir_entry *proc_ocera;
extern struct proc_dir_entry *proc_ocn;
extern int proc_ocera_network_read_state(char *,char **,off_t,int,int *,void *);

#define MAX_OCNET   8


int ocnetd_rt_udp_send(char *, int );

#define OCN_SOCK_IDLE			0x0000
#define OCN_SOCK_FREE			0x1000
#define OCN_SOCK_BUSY			0x0001
#define OCN_SOCK_BIND_WAIT		0x0002
#define OCN_SOCK_UNBIND_WAIT	0x0004
#define OCN_SOCK_BOUND			0x0008
#define OCN_SOCK_CONNECTED		0x0010
#define OCN_SOCK_DEAD			0x0020
#define OCN_SOCK_CREATE_WAIT	0x0040
#define OCN_SOCK_CREATED		0x0080
#define OCN_SOCK_DATAXFER		0x0088
#define OCN_SOCK_CLOSING		0x0100
#define OCN_SOCK_DELETING		0x2000

#define OCN_IDDLE		0x00
#define OCN_DATA_IND    0x01
#define OCN_DATA_REQ    0x02
#define OCN_DATA_ACK    0x03
#define OCN_DATA_REJ    0x04
#define OCN_UNBIND_IND  0x11
#define OCN_UNBIND_REQ  0x12
#define OCN_UNBIND_REJ  0x13
#define OCN_UNBIND_ACK  0x14
#define OCN_BIND_IND	0x21
#define OCN_BIND_REQ	0x22
#define OCN_BIND_REJ	0x23
#define OCN_BIND_ACK	0x24
#define OCN_UNCONN_IND  0x31
#define OCN_UNCONN_REQ  0x32
#define OCN_UNCONN_REJ  0x33
#define OCN_UNCONN_ACK  0x34
#define OCN_CONN_IND	0x41
#define OCN_CONN_REQ	0x42
#define OCN_CONN_REJ	0x43
#define OCN_CONN_ACK	0x44
#define OCN_UDP_IND		0x51
#define OCN_UDP_REQ		0x52
#define OCN_UDP_ACK		0x53
#define OCN_UDP_REJ		0x54
#define OCN_CREATE_REQ	0x62
#define OCN_CREATE_ACK	0x63
#define OCN_CREATE_REJ	0x64
#define OCN_DELETE_REQ	0x72
#define OCN_IOCTL_REQ	0x82
#define OCN_IOCTL_ACK	0x83
#define OCN_GETNAME_REQ	0x92
#define OCN_GETNAME_ACK	0x93
#define OCN_SETOPT_REQ	0xA2
#define OCN_SETOPT_ACK	0xA3
#define OCN_GETOPT_REQ	0xB2
#define OCN_GETOPT_ACK	0xB3
#define OCN_DATA_WAIT   0xE1

typedef struct _ocn_socket	ocn_t ;
extern spinlock_t	ocera_socket_lock;

struct _ocn_socket {
	struct socket 		*s_socket;
	struct sockaddr_in	s_sin;
	struct sockaddr_in	s_remote;
	int					s_sock;
	int 				s_state;
	int 				s_domain;
	int 				s_type;
	int 				s_flags;
	int 				s_protocol;
	ocs_t				*s_stream_up;
	ocs_t				*s_stream_down;
	struct task_struct	*s_thread_up;
	struct task_struct	*s_thread_down;
	struct semaphore	s_sem_up;
	struct semaphore	s_sem_down;
};

#define OCERA_MAX_SOCKET    32
extern ocn_t ocera_socket[OCERA_MAX_SOCKET];

struct ocn_cmd_st {
			short			o_unused;
			unsigned char 	o_cmd;
			unsigned char 	o_sock;
			int				o_flags;
			int				o_parm;
			struct sockaddr_in o_sin;
};


/* THE SOCKET API	*/
extern int ocn_socket(int, int , int);
extern int ocn_bind(int , struct sockaddr_in *, int);
extern int ocn_getsockname(int , struct sockaddr_in *, int);
extern int ocn_sendto(int, void *, size_t, int, struct sockaddr_in *, int);
extern int ocn_recvfrom(int, void *, size_t, int, struct sockaddr_in *, int *);
extern int ocn_close(int);
extern int ocn_delete(int);

/*
extern int ocn_connect(int sock, struct sockaddr_in *, ocera_msgbuf_t *);
extern int ocn_udp_send(int sock, struct sockaddr_in *, ocera_msgbuf_t *);
extern int ocn_init_receive(int,ocera_msgbuf_t * );
extern ocera_msgbuf_t *ocn_receive(int,int);
extern int ocn_send(int,ocera_msgbuf_t *);
*/
extern void ocn_showsocket(struct sockaddr_in *);
extern int ocn_unbind(int);
extern void ocn_release_all(void);
extern void ocn_release(int);
extern int ocn_socket_init(void);
extern void ocn_reset_socket(ocn_t *);
extern int ocn_setsockopt(int,int,int,char *,int);
extern int ocn_getsockopt(int,int,int,char *,int *);
extern int ocn_ioctl(int, unsigned int , void * );
extern int ocn_getname(int, struct sockaddr*, int *);

int OcnetBindSocket(ocn_t *);
int OcnetUnbindSocket(ocn_t *);
int OcnetConnectSocket(ocn_t *);
int OcnetUnbind(ocn_t *);
int OcnetSendUDP( ocn_t *,struct sockaddr_in *, char * , int );
int OcnetReceiveUDP(ocn_t *, char *, struct sockaddr_in * , int );
void OcnetReleaseSocket(ocn_t *);
int OcnetIoctl( ocn_t * sp, unsigned int cmd, void *arg );

